<?php
/* Code created by WhiteWorks */

class SimpleTemplateParser{

	private $vars = array();

	public function assign($key, $value){
		$this->vars[$key] = $value;
	}

    public function assignAndSanitize($key, $value){
        $value = $this->clean($value);
        $this->vars[$key] = $value;
    }

    public function clean($value){
        if (is_array($value)){
            foreach($value as $k => $v){
                $value[$k] = $this->clean($v);
            }
        }
        else if (is_object($value)){
            //skip
        }
        else{
            $value = htmlspecialchars($value, ENT_QUOTES, 'UTF-8');
        }
        return $value;
    }

	public function assignMultiple($arr){
		foreach($arr as $key => $value){
			$this->assign($key, $value);
		}
	}

    public function clearAllAssign(){
        $this->vars = array();
    }

	public function fetch($template, $data = array()){
		$this->assignMultiple($data);

		ob_start();
		//creating a bunch of local variables;
		foreach ($this->vars as $key => $value){
			$$key = $value;
		}
        if(!is_file($template)){
            print '<pre>';
            echo ('file does not exists: '.$template);
            $trace = (debug_backtrace());
            foreach($trace as $t){
                echo "<br/>".$t['file'].' on line '.$t['line'];
            }
            die();
        }

		include($template);
		$buffer = ob_get_contents();
		@ob_end_clean();

		return $buffer;
	}
}
?>